      IMPLICIT REAL*8 (A-H,O-Z) 
C  These parameters set maximum number of:              
C                     molecules
      PARAMETER (NPART  = 1100                             )
C                         types
      PARAMETER (NTPS   =   5                              )
C                        sites            atoms
      PARAMETER (NS     = 1000  , NTOT   = 5000             ) 
C                      close and far neigbours
      PARAMETER (NBSMAX = 64*NTOT,NBLMAX=512*NTOT          )  
C                  different bonds and angles
      PARAMETER (NB     = 1100  , NA     = 1245             )
C               total num of bonds         angles / per processor
      PARAMETER (NBO    = 5000 , NAO     = 5000           )    
C              different torsions      hydrogen bonds
      PARAMETER (NT     = 2000 , NHYD   = 20       )  
C               total torsions    additional LJ interactions
      PARAMETER (NTO    = 8000, NNADM=1000 )                 
C              RDF resolution    num of RDFs     Max RDF for 1 site 
      PARAMETER (MAXS   = 320  , MAXGR  = 30 ,   MXGRS=80)        
C                    points for tcf calculations  ; total tcf
C   set MAXCF=1 if you do not want calculate tcf and want to save memory
      PARAMETER (MAXCF  = 500    , NTCF   = 12               )
      PARAMETER (MAXTCF = (MAXCF+2)*NPART*3                ) 
C                   different averages
      PARAMETER (NRQS   = 10000 , NTPP =(NTPS*(NTPS+1))/2+1 ) 
C   max number of "bound" neighbours 
      PARAMETER (NBDMAX    = 30 )           
C       intermediate averaging points
      PARAMETER (LHIST  = 500) 
	PARAMETER (NBUFF  = 3*NTOT)  ! NBUFF
*
      PARAMETER (AVSNO=6.02252D23,BOLTZ=1.38054D-23,FKCALJ=4.1868)
      PARAMETER (PI=3.1415926536D0,ELECHG=1.602D-19,EPS0=8.854D-12)
      PARAMETER (A1=0.254829592D0,A2=-0.284496736D0,A3=1.421413741D0)
      PARAMETER (A4=-1.453152027D0,A5=1.061405429D0,B1=0.3275911D0)
      PARAMETER (TOTPI=1.128379169D0,PI2=2.D0*PI)
      PARAMETER (TODGR=180.D0/PI)
      parameter (cos30=0.8660254037844386,BOXYC=0.5/cos30,SQ3=2.*cos30)
      
*
      COMMON /COMCOM/  X(NPART), Y(NPART), Z(NPART)
     X               ,PX(NPART),PY(NPART),PZ(NPART)
     X               ,QX(NPART),QY(NPART),QZ(NPART)
      COMMON /SITSIT/ SX(NTOT) ,SY(NTOT) ,SZ(NTOT)
     X               ,VX(NTOT) ,VY(NTOT) ,VZ(NTOT)
     X               ,FX(NTOT) ,FY(NTOT) ,FZ(NTOT)
     X               ,GX(NTOT) ,GY(NTOT) ,GZ(NTOT)
     X               ,HX(NTOT) ,HY(NTOT) ,HZ(NTOT)
     X               ,WX(NTOT) ,WY(NTOT) ,WZ(NTOT)
     X               ,OX(NTOT) ,OY(NTOT) ,OZ(NTOT)
	COMMON /LISTNB/MBSH,MBLN,NBS1(NBSMAX),NBS2(NBSMAX),
     +NBL1(NBLMAX),NBL2(NBLMAX),NNBB(NTOT),INBB(NTOT,NBDMAX)
      REAL*8 MASS,MASSD,MASSDI
      CHARACTER*4 NM,NAM,NAMOL*12,PATHDB*64
      CHARACTER*6 NAME
      CHARACTER*8 NMGR
      character*24 label,fdump,flst,frdf,ftcf,ftrk,fmol,fname*20
      common /NAMES/ label,fdump,flst,frdf,ftrk,fname,ftcf,fmol,PATHDB
      common /TIMESZ/ time0,timel,timeg,timef,timee,timen,timeb,timea,
     +               timet,timest,timev,times
      COMMON /TPSTPS/ NSPEC(NTPS),NSITS(NTPS),IINIT(NTPS)
     X               ,IADDR(NTPS+1),ISADR(NTPS+1),ISADDR(NTPS+1)
     X               ,MDX(NTPS,NTPS),LIST(NTPS),ISHEJK(NTPS)
     X               ,NRB(NTPS),NRA(NTPS),NRT(NTPS),NRI(NTPS)
     X               ,IPOT(NTPS),NRTSC(NTPS),NAME(NTPS),NAMOL(NTPS)
      COMMON /MOLMOL/ SIGMA(NS),EPSIL(NS),CHARGE(NS),R(NS,3),ITS(NS)
     X               ,ITM(NPART),CHYD(0:NHYD,0:NHYD)
     +               ,DHYD(0:NHYD,0:NHYD),EPAD(NNADM),SIGAD(NNADM)
     X               ,MASS(NS),MASSD(NS),NM(NS),IHYD(NS)
     +	  	     ,ILJ(NNADM)
      COMMON /SITTES/ MASSDI(NTOT),Q(NTOT),ITYPE(NTOT)
     +                ,NAM(NTOT),NNUM(NTOT),NSITE(NTOT)
      COMMON /CONTRL/ TIM,TIMA
     +               ,NOP,NSITES,NTYPES,NSTOT,NFREQ,MOLINT,IPRINN
     X               ,NSTEP,NSTEPS,MSTEP,NSTTOT,NNAV,NAVT,NHIST,IHIST
     X               ,NAVER,IPRINT,NTRAJ,NSTEPA,NDUMP,IAVER,ICHECK
     +               ,ITREK,NTREK,NTRKF,LTREK,NTRKZ,ICFN,ICHNB,KMAX  
     +	     ,NRBT,NRAT,NRRT,NRIT,NRAA,NRBB,NRTT,NRII,NHYDB,NHDM,IO,
     +        NNAD,NRBND,ICELL
      COMMON /PHYSIC/ PE,TEMPF,ENERF,COULF,UNITL,UNITE,UNITM,UNITT
     X               ,UNITP,TOTMAS,DT,TSTEP,TSTEB,RHO,RCUTT,TOLER,BDTOL
     X               ,RF,FNST,TKE,TRTEMP,TDELT,AVB,AVA,AVT,TRPRES,FEXP
     +               ,TRYCK,TRID,TRYCKM,VOL,PLJ,PINT,PEL,PEST,PELS,PELR
     X               ,PES,PQE,POTEN,EKINE,ETOT,TEMP,FTIMES,FTSCL,FNOP
     +               ,TTR,TROT,TINT,FNSTI,FNSTR,RCUT,TEMPV,FACVT,RLR
     +               ,QT,QPR,PE1,PELS1,SPE,TTREK,EFACT,PERMOL,SPEE(NTPS)
     +		     ,TRYCKX,TRYCKY,TRYCKZ,RFF,RFF2,HYDF10,HYDF12
     X               ,POTES(NTPP),POTLJ(NTPP),POTE1(NTPP),POTL1(NTPP)
     X               ,PELRC(NTPP),VRLRC(NTPP)
     X               ,EKIN (NTPS),TEMPR(NTPS),SELFPE(NTPS)
     X               ,SUMMAS(NTPS),C14LJ(NTPS),C14EL(NTPS)
     X               ,TFACT(NTPS),QSUM(NTPS)
      common /VIRRR/ VIR,VIRL,VIRB,VIRA(3),VIRT,VIRN,VIRO,WIRF,WIRS,
     +               VIRS,VIRD,VIRLS,WIRSS,VIR1,VIRX,VIRY,VIRZ,
     +               VIRFX,VIRFY,VIRFZ
      COMMON /NVTNPT/ DQT,SC,SCV,DQP,SCL,SCLX,SCLY,SCLZ
      COMMON /SISTEM/ BOXL,BOYL,BOZL,HBOXL,HBOYL,HBOZL,ALPHA,ALPHAD
     X               ,RSSQ,SHORT,SHORT2,SHORTA,CLN,BOXY3
     +               ,RDNA
      COMMON /NBNBNB/ PES14(NTPS),PSR14(NTPS),PES141(NTPS),PSR141(NTPS)
      COMMON /BONBON/ BB(NB),EB(NB),RB(NB),FB(NB),EBOND(NTPS),BR(NB)
     +	       ,BE(NB)
     X               ,DB(NB),RO(NB),IADB(NTPS),IB(NB),JB(NB),ID(NB)
     +	       ,IBI(NBO),JBJ(NBO),IBUK(NBO)
      COMMON /ANGANG/ AA(NA),EA(NA),RA(NA),FA(NA),EANGL(NTPS),AR(NA)
     X               ,AE(NA),IADA(NTPS),IA(NA),JA(NA),KA(NA)
     +	       ,IAI(NAO),JAJ(NAO),KAK(NAO),IAUK(NAO)
      COMMON /TORTOR/ TT (NT),ET (NT),ETORS(NTPS),FT1(NT),FT2(NT)
     X               ,FT3(NT),FT4(NT),FT5 (NT),TR(NT),TE(NT)
     X               ,RT (NT),FT (NT),NMUL(NT)
     X               ,IADT(NTPS),IT(NT),JT(NT),KT(NT),LT(NT)
     X               ,ITORS(NT)
     +	       ,ITI(NTO),JTJ(NTO),KTK(NTO),LTL(NTO),ITUK(NTO)
      COMMON /DIPDIP/ DPX(NPART),DPY(NPART),DPZ(NPART)
      COMMON /VECVEC/ UPX(NPART),UPY(NPART),UPZ(NPART)
      COMMON /ROTROT/ RMX(NPART,3,3)
      COMMON /AVRAWR/ AV(NRQS),AW(NRQS),HIST(NRQS,LHIST)
      LOGICAL        LSCLT,LSCFT,LNVT,LRST,LDMP,LCHL
     X               ,LNPT,LINIT,LMOVE,LRR,LSEP,LOCT,LHEX
     X               ,LINPUT,L0AVS,L0VS,LSHEJK,LCHP,LCHT,LEQ
     X               ,L14NB,L15NB,LXMOL,LMNBL
      COMMON /LOGLOG/ LSCLT,LSCFT,LNVT,LRST,LDMP,LPLT,LCHL
     X               ,LNPT,LXMOL,LINIT,LRR,LSEP,LOCT,LHEX
     X               ,LINPUT,L0AVS,L0VS,LSHEJK,LCHP,LCHT,LEQ
     X               ,L14NB(NTPS),L15NB(NTPS),LMOVE(NTPS),LMNBL
      LOGICAL         LGR,LGDMP,LGRST,ALLSTS
      COMMON /RDFRDF/RDFINC,DRDFI,RDFCUT,RDFCUT2,LGR,LGDMP,LGRST,ALLSTS
     X               ,MAXRDF,MAX,IGR(MAXGR),JGR(MAXGR),IIN(MAXGR)
     X               ,NRDF,IRDF(MAXS,MAXGR),NMGR(0:MAXGR)
     +		,NGRI(NS),IGRI(NS,MXGRS),MGRI(NS,MXGRS)
      CHARACTER*6 NAMECF
      LOGICAL         LCF,LCFDMP,LCFRST
      PARAMETER (MCF=MAXCF*NTPS) 
	real*4 CC1,CC2,CC3,CC4
      COMMON /TCFTCF/ CC1(MAXTCF),CFV(MCF)
     X               ,CC2(MAXTCF),CFA(MCF)
     X               ,CC3(MAXTCF),CP1(MCF),CP2(MCF)
     X               ,CC4(MAXTCF),CU1(MCF),CU2(MCF)
     X               ,CVX(MCF),CVY(MCF),CVZ(MCF)
     X               ,CAX(MCF),CAY(MCF),CAZ(MCF)
     X               ,CCF(MCF)
     X               ,LCF,LCFDMP,LCFRST
     X               ,INX(MAXCF),NCALLS,NSTEG,NSTCF,NOM,JUMP
     X               ,N1(NTPS),N2(NTPS),ITCF(NTCF+4)
     X               ,NAMECF(NTCF)
CM
CM parallel parameters
CM
      parameter (nodes=63)
      integer NUMTASK,TASKID 
	integer NAB(0:NODES),NAE(0:NODES),NABS(0:NODES),NAP(0:NODES),
     +NAP3(0:NODES),NABS3(0:NODES)
      common /PARA/ NUMTASK,TASKID,IDG,LENMP,LENTT,LENIT,NBUF,NAP3,
     +NAP,NAB,NAE,NABS,NORD(NTPS),LENMB,LENMA,LENMT,LENMI,MAST,NAPC,
     +NABS3
*    for safety 
	save




