*
*================ INPUT ===============================================
*                                                                      
*     Data input
	subroutine INPUT   
	include "prcm.h"
	character*80 STR,TAKESTR             
	IE=0
	IO=5                 !  read from standard input 
	STR=TAKESTR(IO,IE) 
	read(STR,*,err=99,end=99)IPRINT                
	if(IPRINT.ge.7)write(*,*)' Checking input: '
	STR=TAKESTR(IO,IE)
	do I=1,72
	  if(STR(I:I).ne.' ')go to 1
	end do
 1	LD=LENG(STR,80)
	FNAME=STR(I:LD)    
	if(IPRINT.ge.7)write(*,*)' Basis file name ',FNAME
	STR=TAKESTR(IO,IE)
	do I=1,72
	  if(STR(I:I).ne.' ')go to 2
	end do
 2	LD=LENG(STR,80)
	PATHDB=STR(I:LD)
	if(IPRINT.ge.7)write(*,*)' Molecular database path ',PATHDB
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)LRST,LDMP,LINPUT,L0AVS   
	if(IPRINT.ge.7.and.LRST)
     +write(*,*)' restart from ',FNAME(1:LD)//'.dmp'
	if(IPRINT.ge.7.and.LDMP)write(*,*)' restart file will be dumped'
	if(IPRINT.ge.7.and.LINPUT)write(*,*)
     +' only check input or results'
	if(IPRINT.ge.7.and.L0AVS)write(*,*)' count cpu time from 0'
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)LNVT,LNPT,LSEP  
	if(.not.LNPT)LSEP=.false.
	if(IPRINT.ge.7.and.LNVT)write(*,*)' constant temperature'
	if(IPRINT.ge.7.and.LNPT)write(*,*)' constant pressure'
	if(IPRINT.ge.7.and.LSEP)write(*,*)
     +' separate scaling box of sizes'
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)NTYPES
	if(IPRINT.ge.7)write(*,*)' number of molecule species: ',NTYPES
      IF(NTYPES.GT.NTPS) STOP '!!! INCREASE NTPS !'
	STR=TAKESTR(IO,IE)
CC Attention!! 80 is length of STR in this file 
CC of NAMOL - see prcm.h
CC 
*       read(STR,*,err=99,end=99)(NAMOL(I),I=1,NTYPES)
	call PARSES(STR,NAMOL,NTYPES,80,ie)
	if(ie.ne.0)go to 99
	if(IPRINT.ge.7)write(*,*)' names of molecules of each specii: ',
     + (NAMOL(I),I=1,NTYPES)
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)(NSPEC(I),I=1,NTYPES)
	if(IPRINT.ge.7)write(*,*)' number of molecules of each specii: ',
     + (NSPEC(I),I=1,NTYPES)
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)(L15NB(I),I=1,NTYPES)
	if(IPRINT.ge.7)write(*,*)' 1-5 intramolec.interactions : ',
     + (L15NB(I),I=1,NTYPES)
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)(L14NB(I),I=1,NTYPES)
	if(IPRINT.ge.7)write(*,*)' 1-4 intramolec.interactions : ',
     + (L14NB(I),I=1,NTYPES)
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)(C14LJ(I),I=1,NTYPES)
	if(IPRINT.ge.7)write(*,*)
     +' Scaling factors for 1-4 LJ intramolec.interactions : ',
     + (C14LJ(I),I=1,NTYPES)
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)(C14EL(I),I=1,NTYPES)
	if(IPRINT.ge.7)write(*,*)
     +' Scaling factors for 1-4 electrost. intramolec.interactions:',
     + (C14EL(I),I=1,NTYPES)
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)(IPOT(I),I=1,NTYPES)
	if(IPRINT.ge.7)write(*,*)' intramolecular potential type: ',
     + (IPOT(I),I=1,NTYPES)
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)TRTEMP,RHO,TRPRES
	if(IPRINT.ge.7)write(*,*)' temperature ',TRTEMP
	if(IPRINT.ge.7)write(*,*)' pressure ',TRPRES
	STR=TAKESTR(IO,IE)
	read(STR,*,err=29,end=29)BOXL,BOYL,BOZL,ICELL
	go to 30
 29	ICELL=0
	read(STR,*,err=99,end=99)BOXL,BOYL,BOZL
 30	LOCT=.false.
	LHEX=.false.
	if(ICELL.eq.1)LOCT=.true.
	if(ICELL.eq.2)LHEX=.true.
	if(LOCT)then
	  BOYL=BOXL
	  BOZL=BOXL  
	  LSEP=.false.
	end if           
	if(LHEX)BOYL=BOXL*cos30
	if(IPRINT.ge.7)then  
	  if(LOCT)write(*,*)' truncated octahedron geometry '
	  if(BOXL*BOYL*BOZL.le.0)then
	    write(*,*)' density ',RHO
	  else
	    write(*,*)' box sizes: ',BOXL,BOYL,BOZL
	  end if
	end if
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)DT,NFREQ
	if(IPRINT.ge.7)write(*,*)' Large time step ',DT
	if(IPRINT.ge.7)write(*,*)' Small time step ',DT/(NFREQ+1.d-14)
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)NSTEPS,NAVER,IAVER,NDUMP
	if(IPRINT.ge.7)write(*,*)' Total number of MD time steps ',NSTEPS
	if(IPRINT.ge.7)write(*,*)
     +' MD time steps for intermediate averaging',NAVER
	if(IPRINT.ge.7)write(*,*)' Take averages each ',IAVER,' steps'
	if(IPRINT.ge.7)write(*,*)' Restart file after ',NDUMP,' steps'
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)QT,QPR,LSCLT,TDELT
	if(IPRINT.ge.7)write(*,*)' Termostat parameters ',QT,QPR
	if(IPRINT.ge.7.and.LSCLT)write(*,*)
     +' Allowed temperature fluctuations ',TDELT
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)RCUT,SHORT,ICHNB
	if(IPRINT.ge.7)write(*,*)' Cut off radius ',RCUT
	if(IPRINT.ge.7)write(*,*)' Cut off for fast forces ',SHORT
	if(IPRINT.ge.7)write(*,*)' Check neighbours after ',ICHNB,
     +' steps'
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)ALPHA,FEXP
	if(IPRINT.ge.7)write(*,*)' Ewald parameters ',ALPHA,FEXP
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)(LMOVE(I),I=1,NTYPES)
	if(IPRINT.ge.7)write(*,*)'move molecules: ',(LMOVE(I),I=1,NTYPES)
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)LINIT
	if(IPRINT.ge.7.and.LINIT)write(*,*)
     +'recalculate intramolec. neigbours list '
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)LSHEJK
	if(LSHEJK)read(STR,*,err=99,end=99)LSHEJK,TOLER,
     +(ISHEJK(I),I=1,NTYPES)
	if(IPRINT.ge.7.and.LSHEJK)then
	  write(*,*)'Constrain dynamics. TOLER= ',TOLER
	  write(*,*)'These molecules are rigid:'
	  do I=1,NTYPES
	    if(ISHEJK(I).gt.0)write(*,*)NAMOL(I)
	  end do
	end if  
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)ICHECK,L0VS
	if(IPRINT.ge.7)write(*,*)' Initial state parameter ',ICHECK
	if(IPRINT.ge.7.and.L0VS)write(*,*)' set velocities to 0 '
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)(IINIT(I),I=1,NTYPES)
	if(IPRINT.ge.7)write(*,*)' Initial orientation parameter',
     +(IINIT(I),I=1,NTYPES)
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)RDNA,LRR,RLR
	if(IPRINT.ge.7.and.(ICHECK.eq.2.or.ICHECK.eq.3))write(*,*)
     +' Radius of the hole for a large molecule',RDNA 
	if(IPRINT.ge.7.and.LRR)write(*,*)
     +' Deviation from ".mol" structure',RLR 
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)LCHT,LCHP
	if(IPRINT.ge.7.and.LCHT)write(*,*)
     +' Set temperature from the input file'
	if(IPRINT.ge.7.and.LCHT)write(*,*)
     +' Set density or box size from the input file'
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)IHIST,LXMOL
	if(IPRINT.ge.7)write(*,*)' final averaging from ',IHIST,
     +' fragment '
	if(IPRINT.ge.7.and.LXMOL)write(*,*)
     +' Dump configuration for XMOL program'
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)LSCFT,FTSCL
	if(IPRINT.ge.7.and.LSCFT)write(*,*)' Scale forces to ',
     +1./FTSCL,'i.u.'
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)LGR,LGDMP,LGRST
	if(IPRINT.ge.7.and.LGR)write(*,*)' calculate RDF'
	if(IPRINT.ge.7.and.LGRST)write(*,*)' restart RDF file'
	if(IPRINT.ge.7.and.LGDMP)write(*,*)' dump RDF file'
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)ALLSTS,RDFCUT,MAX
	if(IPRINT.ge.7.and.ALLSTS)write(*,*)' RDF for all site pairs'
	if(IPRINT.ge.7)write(*,*)' RDF cut off ',RDFCUT 
	if(IPRINT.ge.7)write(*,*)' RDF resolution ',RDFCUT/MAX 
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)ITREK,TTREK,LTREK
	if(IPRINT.ge.7.and.ITREK.gt.0)write(*,*)
     +' Dump configurations each ',TTREK,' s ',LTREK,' conf. per file'
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)(LIST(I),I=1,NTYPES)
	if(IPRINT.ge.7.and.ITREK.gt.0)write(*,*)
     +' Include molecules: ',(LIST(I),I=1,NTYPES)
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)LCF,LCFRST,LCFDMP,NSTEG,JUMP
	if(IPRINT.ge.7.and.LCF)write(*,*)' calculate TCF'
	if(IPRINT.ge.7.and.LCFRST)write(*,*)' restart TCF file'
	if(IPRINT.ge.7.and.LCFDMP)write(*,*)' dump TCF file'
	if(IPRINT.ge.7.and.LCF)write(*,*)' TCF for ',NSTEG,
     + ' steps with jump = ',JUMP
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)(ITCF(I),I=1,NTCF)
	if(IPRINT.ge.7.and.LCF)write(*,*)' which tcf calculate:',
     +(ITCF(I),I=1,NTCF)
	STR=TAKESTR(IO,IE)
	read(STR,*,err=99,end=99)(N1(I),I=1,NTYPES)
	STR=TAKESTR(IO,IE)                              
	read(STR,*,err=99,end=99)(N2(I),I=1,NTYPES)
	do I=1,NTYPES
	  if(N1(I).le.0)N1(I)=1
	  if(N2(I).le.0)N2(I)=1
	end do
	if(IPRINT.ge.7.and.LCF)write(*,*)
     +' unit vector for reorientation tcf:'
	if(IPRINT.ge.7.and.LCF)write(*,*) (N1(I),I=1,NTYPES)
	if(IPRINT.ge.7.and.LCF)write(*,*) (N2(I),I=1,NTYPES) 
	write(*,*)' Read input data '
      return   
* Diagnos                             
 99	IE=99
	STR=TAKESTR(IO,IE)
	write(*,*)' Reboot ... '
	end
*
*================ READMOL =============================================
*
*    Define molecule from DATABASE
	subroutine READMOL(SUMM,NX,NTYP,NAMN)
	include "prcm.h"
*
      DIMENSION CM(3)
	character namn*12,STR*80,FIL*80,TAKESTR*80,NAMH*4,NMF*5
        FIL=' '                    
	IE=0
	NTYP        = NTYP+1 
	NX0=NX
      LD=LENG(PATHDB,62)
	FIL(1:LD)=PATHDB(1:LD)
        FIL(LD+1:LD+1)='/'
	LN=LENG(NAMN,12)
	FIL(LD+2:LD+LN+1)=NAMN(1:LN)
	FIL(LD+LN+2:LD+LN+5)='.mol'
	open(unit=12,file=fil,status='old',err=999)
	if(IPRINT.ge.5)
     +PRINT * ,'*** MOLECULE ',NAMN,',  Type  No.',NTYP
	IE=0
	STR=TAKESTR(12,IE)
	read(STR,*,err=99,end=99)NSTS
	if(IPRINT.ge.6)PRINT * ,'*** NR OF SITES:                ',NSTS
	NSITS(NTYP)=NSTS
	NSBEG=NX+1 
*  check unit vector             
	if(LCF)then 
	  if(N1(NTYP).gt.NSTS)then  
	    N1(NTYP)=1
	    write(*,*)
     +    '!!! Too large site number for unit vector. Set to 1'
	  end if  
	  if(N2(NTYP).gt.NSTS)then  
	    N2(NTYP)=NSTS
	    write(*,*)
     +    '!!! Too large site number for unit vector. Set to ',NSTS
	  end if  
	end if
	do I=1,NSTS
	  STR=TAKESTR(12,IE)
	  IX=NX+I
	  NM(IX)=STR(1:4)
	  read(STR(6:80),*,err=99,end=99)(R(IX,J),J=1,3),
     +  MASS(IX),CHARGE(IX),SIGMA(IX),EPSIL(IX)
          if(IPRINT.ge.6)
     +      write(*,'(a5,a4,a4,3f7.3,a3,f8.4,a3,f6.3,a5,f8.4,a4,f9.4)')
     +      'atom ',NM(IX),'  R=',(R(IX,J),J=1,3),
     +      ' M=',MASS(IX),' Q=',CHARGE(IX),' si=',
     +      SIGMA(IX),' eps=',EPSIL(IX)
	end do
	NSEND=NX+NSTS
* COM coordinates 
	SUMM       = 0.D0
      DO IS      = NSBEG,NSEND
        SUMM       = SUMM+MASS(IS)
      END DO! OF IS
*
      CM(1)      = 0.D0
      CM(2)      = 0.D0
      CM(3)      = 0.D0
      DO IS      = NSBEG,NSEND
        CM(1)      = CM(1)+R(IS,1)*MASS(IS)
        CM(2)      = CM(2)+R(IS,2)*MASS(IS)
        CM(3)      = CM(3)+R(IS,3)*MASS(IS)
      END DO! OF IS
*
      CM(1)      = CM(1)/SUMM
      CM(2)      = CM(2)/SUMM
      CM(3)      = CM(3)/SUMM
*     
	if(IINIT(NTYP).eq.0)then
        DO K       = 1,3
          DO IS      = NSBEG,NSEND
            R(IS,K)    = R(IS,K)-CM(K)
          END DO! OF IS
        END DO! OF I
	end if
*  Output of the reference
	STR=TAKESTR(12,IE)
	read(STR,*,err=99,end=99)NSR
	do I=1,NSR
	  STR=TAKESTR(12,IE)
	  if(IPRINT.ge.6)write(*,'(a80)')STR
	end do
	if(IPRINT.ge.8)then
        PRINT *,'*** Molecular GEOMETRY (C.O.M. IN ORIGIN): '
        DO IS      = NSBEG,NSEND
          PRINT "('*** ',I4,3x,A4,3X,3(1X,F7.3))",
     +    IS,NM(IS),R(IS,1),R(IS,2),R(IS,3)
        END DO! OF IS
      end if
*
	if(IPRINT.ge.10)then
        PRINT *
        PRINT *,'*** INTER ATOMIC DISTANCES '
        do IS=NSBEG,NSEND
	    do JS=IS+1,NSEND
	      RR2=0.
	      do K=1,3
	        RR2=RR2+(R(IS,K)-R(JS,K))**2
	      end do
 	      RR=sqrt(RR2)
            PRINT "('*** ',A4,'-  ',A4,'  --> ',F7.3)",
     +      NM(IS  ),NM(JS),RR
	    end do
	  end do
	end if
*  Bonds
	STR=TAKESTR(12,IE)
	read(STR,*,err=99,end=99)NBD
	NRB(NTYP)=NBD
	do K=NRBB+1,NRBB+NBD
	  STR=TAKESTR(12,IE)
	  read(STR,*,err=99,end=99)ID(K),IB(K),JB(K),RB(K),FB(K),
     + DB(K),RO(K)
	  if(RB(K).le.0.d0)RB(K)=sqrt((R(IB(K),1)-R(JB(K),1))**2+
     +  (R(IB(K),2)-R(JB(K),2))**2+(R(IB(K),3)-R(JB(K),3))**2)
	end do
	if(IPRINT.ge.8.and.NBD.gt.0)then
        PRINT *
        PRINT "('*** PARAMETERS FOR ',I3,'  BONDS')",NBD
        PRINT *,'*** HARMONIC POTENTIALS:'
        IDTOT      = 0
        DO M       = NRBB+1,NRBB+NBD
          if(ID(M).ne.0)IDTOT=IDTOT+1
          write(*,'(a5,a4,a1,a4,2I6,a,f8.4,a,f8.2)')
     +    'Bond ',NM(IB(M)+NX),'-',NM(JB(M)+NX),IB(M),JB(M),' Req.=',
     +    RB(M),'   Force=',FB(M)
        END DO! OF M
*
        IF(IDTOT.GT.0) THEN
          PRINT *
          PRINT *,'*** MORSE POTENTIALS:'
          DO M       = NRBB+1,NRBB+NRB(NTYP)
            if(ID(M).ne.0)
     +      PRINT "('*** BOND: ',I3,'  - ',I3,'  RO: ',F7.3,'  DISS  ',
     X      'ENERGY  :',F9.3)",IB(M),JB(M),RO(M),DB(M)
          END DO! OF M
        END IF
	end if
*  Angles
	STR=TAKESTR(12,IE)
	read(STR,*,err=99,end=99)NAN
	NRA(NTYP)=NAN   
	do K=NRAA+1,NRAA+NAN
	  STR=TAKESTR(12,IE)
	  read(STR,*,err=99,end=99)IA(K),JA(K),KA(K),RA(K),FA(K)
	  if(RA(K).le.0)RA(K)=ANGLG(R,IA(K),JA(K),KA(K),NS)*TODGR
	end do
	if(IPRINT.ge.8.and.NAN.gt.0)then
	  PRINT *
        PRINT *,'*** COVALENT ANGLES '
	  do K=NRAA+1,NRAA+NAN
          PRINT "('***',3i6,3(1X,A4),'  ->',F9.3,'  Force c.',f9.3)",
     +       IA(K) ,   JA(K) ,   KA(K) ,
     +    NM(IA(K)+NX),NM(JA(K)+NX),NM(KA(K)+NX),RA(K),FA(K)        
	  end do
	end if
*  Dihedrals ( standard 1+cos(al+n*f) type )
      STR=TAKESTR(12,IE)
	read(STR,*,err=99,end=99)NTT       
	NRT(NTYP)=NTT
	if(NTT.gt.0)then
	  do K=NRTT+1,NRTT+NTT
	    ITORS(K)=0
	    STR=TAKESTR(12,IE)
	    read(STR,*,err=99,end=99)
     +	    IT(K),JT(K),KT(K),LT(K),RT(K),FT(K),NMUL(K)
	    FT2(K)=0.d0
	    FT3(K)=0.d0
	    FT4(K)=0.d0
	    FT5(K)=0.d0
	  end do
	  if(IPRINT.ge.8)then
	    PRINT *
          PRINT *,'*** DIHEDRALS '
	    write(*,*)'  1+cos(nf) type:'
	    do K=NRTT+1,NRTT+NTT
              PRINT"(4I6,4(1X,A4),' ->',I2,F8.2,'  F.c.',f9.3)"
     +      ,   IT(K),JT(K),KT(K),LT(K)
     +         ,NM(IT(K)+NX),NM(JT(K)+NX),NM(KT(K)+NX),NM(LT(K)+NX),
     +        NMUL(K),RT(K),FT(K)        
	    end do
	  end if
      end if                 
      NRBB         = NRBB+NRB(NTYP)
      NRAA         = NRAA+NRA(NTYP)
      NRTT         = NRTT+NRT(NTYP)
*
*  Optional force field terms
*                       
 100	IE=-1
      STR=TAKESTR(12,IE)  
	if(IE.lt.0)go to 20
	do I=1,72
	  if(STR(I:I).ne.' ')go to 105
	end do
	go to 100
 105  NMF=STR(I:I+4)
	if(NMF.eq.'Tors1'.or.NMF.eq.'tors1'.or.NMF.eq.'TORS1')then	
*    Dihedral of Sum(cos(nf)) type
        STR=TAKESTR(12,IE)
	  read(STR,*,err=99,end=99)NTT       
	  NRT(NTYP)=NRT(NTYP)+NTT
	  if(NTT.gt.0)then
	    do K=NRTT+1,NRTT+NTT  
	      ITORS(K)=1
	      STR=TAKESTR(12,IE)
	      read(STR,*,err=99,end=99)
     +	    IT(K),JT(K),KT(K),LT(K),FT1(K),FT2(K),FT3(K)
	      NMUL(K)=0   
	      FT(K)=0.d0 
	      RT(K)=0.d0 
	      RT(K)=0.d0 
	      FT4(K)=0.d0
	      FT5(K)=0.d0
	    end do
	    if(IPRINT.ge.8)then
	      PRINT *
            PRINT *,'*** DIHEDRALS '
	      write(*,*)'  Sum(1+Cos(nf)) type'
	      do K=NRTT+1,NRTT+NTT
              PRINT"(4I6,4(1X,A4),' -> ',3f9.3)",
     +        IT(K),JT(K),KT(K),LT(K),
     +        NM(IT(K)+NX),NM(JT(K)+NX),NM(KT(K)+NX),NM(LT(K)+NX),
     +        FT1(K),FT2(K),FT3(K)        
	        FT1(K)=0.5*FT1(K)
	        FT2(K)=0.5*FT2(K)
	        FT3(K)=0.5*FT3(K)
	      end do
	    end if
          NRTT         = NRTT+NTT
	  end if
	else if(NMF.eq.'Tors5'.or.NMF.eq.'tors5'.or.NMF.eq.'TORS5')then	
*    Dihedral of Sum(cos(f)**n) type
        STR=TAKESTR(12,IE)
	  read(STR,*,err=99,end=99)NTT       
	  NRT(NTYP)=NRT(NTYP)+NTT
	  if(NTT.gt.0)then
	    do K=NRTT+1,NRTT+NTT  
	      ITORS(K)=5
	      STR=TAKESTR(12,IE)
	      read(STR,*,err=99,end=99)
     +      IT(K),JT(K),KT(K),LT(K),FT1(K),FT2(K),FT3(K),FT4(K),FT5(K)
	      NMUL(K)=0   
	      FT(K)=-(FT1(K)+FT2(K)+FT3(K)+FT4(K)+FT5(K)) 
	      RT(K)=180.d0 
	    end do
	    if(IPRINT.ge.8)then
	      PRINT *
            PRINT *,'*** DIHEDRALS '
	      write(*,*)'  Sum(Cosf)**n type'
	      do K=NRTT+1,NRTT+NTT
              PRINT"(4I6,4(1X,A4),' ->',5f8.2)",
     +        IT(K),JT(K),KT(K),LT(K),
     +        NM(IT(K)+NX),NM(JT(K)+NX),NM(KT(K)+NX),NM(LT(K)+NX),
     +        FT1(K),FT2(K),FT3(K),FT4(K),FT5(K)        
	      end do
	    end if
          NRTT         = NRTT+NTT
	  end if
	else if(NMF.eq.'Impro'.or.NMF.eq.'impro'.or.NMF.eq.'IMPRO')then	
*  Improper dihedrals
        STR=TAKESTR(12,IE)
	  read(STR,*,err=99,end=99)NTT       
	  NRT(NTYP)=NRT(NTYP)+NTT
	  if(NTT.gt.0)then
	    do K=NRTT+1,NRTT+NTT  
	      ITORS(K)=-1
	      STR=TAKESTR(12,IE)
	      read(STR,*,err=99,end=99)
     +      IT(K),JT(K),KT(K),LT(K),RT(K),FT(K)
	      NMUL(K)=0   
	    end do
	    if(IPRINT.ge.8)then
	      PRINT *
            PRINT *,'*** Improper DIHEDRALS '
	      do K=NRTT+1,NRTT+NTT
              PRINT"(4I6,4(1X,A4),' ->',5f8.2)",
     +        IT(K),JT(K),KT(K),LT(K),
     +        NM(IT(K)+NX),NM(JT(K)+NX),NM(KT(K)+NX),NM(LT(K)+NX),
     +        RT(K),FT(K)        
	      end do
	    end if
          NRTT         = NRTT+NTT
	  end if
	else if(NMF.eq.'Hydro'.or.NMF.eq.'hydro'.or.NMF.eq.'HYDRO')then		
*  Hydrogen bonds    ( additional 10-12 potential)
	  STR=TAKESTR(12,IE)    
	  I=0
	  read(STR,*,err=99,end=99)NHT
	  if(NHT.gt.0)NHDM=NHDM+NSPEC(NTYP) 
	  if(NHT.gt.0.and.IPRINT.ge.6)write(*,*)'  hydrogen bonds:'
	  do I=1,NHT
	    STR=TAKESTR(12,IE)           
	    read(STR,*,err=99,end=99)NAMH,ITPH
	    do J=1,NSTS
            IS=NX0+J 
	      if(NM(IS).eq.NAMH)then 
	        IHYD(IS)=ITPH
	        NHYDB=NHYDB+1 
	        if(IPRINT.ge.6)write(*,*)NAMH,' site ',IS,' typ H: ',ITPH
	      end if
	    end do
	  end do
	else if(NMF.eq.'Speci'.or.NMF.eq.'speci'.or.NMF.eq.'SPECI')then		
*  List of specific 1-4 interactions
 	  STR=TAKESTR(12,IE)
	  read(STR,*,err=99,end=99)IADLJ 
	  if(IPRINT.ge.6)write(*,*)' Overwrite ',IADLJ,' LJ parameters'
	  do I=NNAD+1,NNAD+IADLJ
	    STR=TAKESTR(12,IE)
	    read(STR,*,err=99,end=99)ILJ(I),SIGAD(I),EPAD(I) 
	    ILJ(I)=ILJ(I)+NX
	    if(IPRINT.ge.8)write(*,'(i4,2x,a4,2x,2f12.3)')
     +    ILJ(I),NM(ILJ(I)),SIGAD(I),EPAD(I)
	  end do   
	  NNAD=NNAD+IADLJ
	  if(NNAD.gt.NNADM)stop ' increase NNADM'
	else if(NMF(1:3).eq.'End'.or.NMF(1:3).eq.'end'.or.
     +NMF(1:3).eq.'END')then
	  go to 20	
	else
	  LD=LENG(STR,73)
	  write(*,*)' !!! Potential for ',STR(I:LD),' not implemented'
	  write(*,*)' !!! Molecule ',NAMOL(NTYP)
	end if
	go to 100
*
 20   IADB(NTYP)   = NRBB-NRB(NTYP)+1
      IADA(NTYP)   = NRAA-NRA(NTYP)+1
      IADT(NTYP)   = NRTT-NRT(NTYP)+1
	NX=NX+NSTS
	close (12)
	return                      
 99	IE=99
	STR=TAKESTR(12,IE)
	write(*,*)' This message should not appear on the screen ...'
 999  write(*,*)'!!! Molecule ',NAMN,' not found in the data base'
      write(*,*)'    File not found: ',FIL
	stop
	end 
*
*============== TAKESTR =========================================
*
      character*80 function TAKESTR(KAN,IE)
	character*80 AUX, fn*32 
	integer LCOUNT(256)   
	data LCOUNT /256*0/
	save AUX,LCOUNT           
	if(IE.eq.99)go to 10 
 1	LCOUNT(KAN)=LCOUNT(KAN)+1
 	read(KAN,'(a80)',err=10,end=20)AUX
	if(AUX(1:1).eq.'#')go to 1
	TAKESTR=AUX 
	IE=0
	return
 10	write(*,*)'!!! error in input file '   
	if(KAN.eq.5)then
	  write(*,*)' Standard input ' 
	else
	  inquire(unit=KAN,name=fn) 
	  write(*,*)' File ',fn
	end if
	write(*,*)' in line ',LCOUNT(KAN)
	write(*,*)AUX
	stop
 20	if(IE.ge.0)then
 	  write(*,*)'!!! end of file reached' 
	  if(KAN.eq.5)then
	    write(*,*)' Standard input ' 
	  else
	    inquire(unit=KAN,name=fn) 
	    write(*,*)' File ',fn
	  end if
	  stop
	end if  
	TAKESTR='  ' 
	IE=-1
	return
	end 
*
*=============== ANGLG =============================================
*
	FUNCTION ANGLG(R,I,J,K,N)
      IMPLICIT real*8 (A-H,O-Z)
      DIMENSION R(N,3)
	RIJ=0.
	RJK=0.
	SC=0.
	DO M=1,3
	  RIJ=RIJ+(R(I,M)-R(J,M))**2
        RJK=RJK+(R(J,M)-R(K,M))**2
        SC =SC +(R(I,M)-R(J,M))*(R(K,M)-R(J,M))
	end do
      ANGLG = DACOS(SC/sqrt(RIJ*RJK))
      RETURN
      END
*
*================ LENG ===============================================
*
	function LENG(STR,LS)
	character*1 STR(LS)
	IL=0 
	do I=1,LS
	  ISTR=ichar(STR(I))
	  if(ISTR.le.15)then
	    LENG=I-1
	    return
	  end if
        if(STR(I).ne.' ')IL=I
	end do 
	LENG=IL
	return
      end    
*
*================== HYDRO ==============================================
*                                                                       
	subroutine HYDRO
*  read parameters for hydrogen bonds from file hydro.bonds
	include "prcm.h"
	character FIL*80,STR*80,NAMN*12,TAKESTR*80 
      NAMN = 'hydro.bonds'
      LD=LENG(PATHDB,62)
	FIL(1:LD)=PATHDB(1:LD)
      FIL(LD+1:LD+1)='/'
	LN=LENG(NAMN,12)
	LF=LD+LN+1
	FIL(LD+2:LF)=NAMN(1:LN)
	IE = 0
      open(unit=13,file=FIL(1:LF),status='old',err=100)
	STR=TAKESTR(13,IE)
	I=0
	read(STR,*,err=99,end=99)NLINES 
      do I=1,NLINES
	  STR=TAKESTR(13,IE)
	  read(STR,*,err=99,end=99)IH,JH,CHYD(IH,JH),DHYD(IH,JH)
	  CHYD(JH,IH)=CHYD(IH,JH)
	  DHYD(JH,IH)=DHYD(IH,JH)
	  if(IH.gt.NHYD.or.JH.gt.NHYD)stop ' increase NHYD'
	end do 
	close (13)
	if(IPRINT.ge.5)write(*,*)
     +' read file with hydrogen bond parameters ',NAMN
	return
 99	IE=99
	STR=TAKESTR(13,IE)
	write(*,*)' Kernel panic ...'
 100  write(*,*)' file ',fil,' not found'
	return
	end
*
*========= PARSES ============================
*
	subroutine PARSES(STR,CH,N,L,ie)
*  Do  read(STR,*)(CH(I),I=1,N)  for stupid compilers
	character STR(L),CHR
C  12 is length of NAMOL in prcm.h
	character*12 CH(N)
	logical LI
	do I=1,N
	   do J=1,12
	      CH(I)(J:J)=' '
	   end do
	end do
	LI=.false.
	M=0
	ie=0
	do I=1,L
	  CHR=STR(I)
	  ICHR=ichar(CHR)
	  if(LI)then
C  Delimiters - space, null and tab
	     if(CHR.eq.' '.or.ICHR.eq.0.or.ICHR.eq.9)then		
		LI=.false.
	     else
		IC=IC+1
C  12 is length of NAMOL in prcm.h
		if(IC.le.12)CH(M)(IC:IC)=CHR
	     end if
	  else
	     if(CHR.ne.' '.and.ICHR.ne.0.and.ICHR.ne.9)then
		M=M+1
		CH(M)(1:1)=CHR
		IC=1
		LI=.true.
	     end if
	  end if
	end do
	if(M.lt.N)ie=1
	return
	end

	
	   
