*=============== SHEJK ===========================================
*
      SUBROUTINE SHEJK(IMOL)
*
      include "prcm.h"
*
      LOGICAL MOVING(NTOT),MOVED (NTOT),DONE
      real*8 VIR11(3)
      PARAMETER (MAXIT=2000)
*
      VIR11(1)	= 0.         
      VIR11(2)	= 0.         
      VIR11(3)	= 0.         
	ITYP=ITM(IMOL)
      NRBS      = NRB(ITYP)
	if(ISHEJK(ITYP).le.0.or.NRBS.le.0)return
      TOL2      = TOLER**2
*
      NBBEG     = IADB(ITYP)
      NBEND     = NBBEG+NRBS-1
*
      ISHF      = ISADDR(ITYP)+NSITS(ITYP)*(IMOL-IADDR(ITYP)-1)
      ISBEG     = ISHF+1
      ISEND     = ISHF+NSITS(ITYP)
*>    
*      DO K      = 1,NSP
*>
*        NTS       = (K-1)*NSS
	DO M      = NBBEG,NBEND
*        IBB       = IB(M)+ISHF
*        JBB	      = JB(M)+ISHF
*	  LI        = NTS+IBB
*	  LJ	    = NTS+JBB
	  LI	= IB(M)+ ISHF
	  LJ	= JB(M)+ ISHF
        MOVING(LI) = .FALSE.
        MOVED (LI) = .TRUE.
        MOVING(LJ) = .FALSE.
        MOVED (LJ) = .TRUE.
      END DO! OF M
*
* Begin iterations:
*     
      ITER      = 0
      DONE      = .FALSE.
*<
    1 CONTINUE
*<
      IF(ITER.GT.MAXIT) GO TO 1000
      IF(.NOT.DONE) THEN
*     
        DONE      = .TRUE.
        DO M      = NBBEG,NBEND
          I       = IB(M)+ISHF
          J       = JB(M)+ISHF
          IF(MOVED(I).OR.MOVED(J)) THEN
            AMAS      = 1.D0/MASSDI(I)
            BMAS      = 1.D0/MASSDI(J)
            BNDSQ     = RB(M)**2
*Unconstrained positions at step n+1
            BXN       = SX(I)-SX(J)
            BYN       = SY(I)-SY(J)
            BZN       = SZ(I)-SZ(J)
	      call PBC(BXN,BYN,BZN)
            BSQ       = BXN**2+BYN**2+BZN**2
            DIFFSQ    = BNDSQ-BSQ
      if(IPRINT.ge.10)then
      write(*,'(3i5,f9.6,4(2x,l1),i5)')
     +K,I,J,sqrt(BSQ),moved(I),moved(j),moving(I),moving(j),ITER
      end if
*
            IF(DABS(DIFFSQ).GT.(BNDSQ*TOL2))THEN
*
Constrained positions from step n
              DXN       = OX(I)-OX(J)
              DYN       = OY(I)-OY(J)
              DZN       = OZ(I)-OZ(J)
		call PBC(DXN,DYN,DZN)
              VDOT      = BXN*DXN+BYN*DYN+BZN*DZN
              IF(VDOT.LT.BNDSQ*BDTOL) THEN
      WRITE(6,66) I,SX(I),SY(I),SZ(I),OX(I),OY(I),OZ(I)
      WRITE(6,66) J,SX(J),SY(J),SZ(J),OX(J),OY(J),OZ(J)
*
      PRINT *,'NEW DISTANCE:',DSQRT((SX(I)-SX(J))**2
     X                             +(SY(I)-SY(J))**2
     X                             +(SZ(I)-SZ(J))**2)
      PRINT *,'OLD DISTANCE:',DSQRT((OX(I)-OX(J))**2
     X                             +(OY(I)-OY(J))**2
     X                             +(OZ(I)-OZ(J))**2)
*
   66 FORMAT(1X,I5,3(1X,F10.6),3X,3(1X,F10.6))
*!    STOP 'CONSTRAINED FAILURE'
      print *,' ... constraint failure!'
              END IF
              RMA       = MASSDI(I)
              RMB       = MASSDI(J)
              GAB       = DIFFSQ/(2.D0*(RMA+RMB)*VDOT)
              DXN       =   DXN*GAB
              DYN       =   DYN*GAB
              DZN       =   DZN*GAB
              SX(I)     = SX(I)+RMA*DXN
              SY(I)     = SY(I)+RMA*DYN
              SZ(I)     = SZ(I)+RMA*DZN
              SX(J)     = SX(J)-RMB*DXN
              SY(J)     = SY(J)-RMB*DYN
              SZ(J)     = SZ(J)-RMB*DZN
              MOVING(I) = .TRUE.
              MOVING(J) = .TRUE.
              DONE      = .FALSE.
            END IF
          END IF
        END DO! OF M - all bonds
* 
*  Obs!    These are separate loops ( Reccurence possible )
*
        DO M      = NBBEG,NBEND
          I       = IB(M)+ISHF
	    J	      = JB(M)+ISHF
	    MOVED(I)  = .false.
          MOVED(J)  = .false.
        END DO! OF M
        DO M      = NBBEG,NBEND
          I       = IB(M)+ISHF
	    J	    = JB(M)+ISHF
          if(MOVING(I))MOVED(I)=.true.
          MOVING(I) = .FALSE.
          if(MOVING(J))MOVED(J)=.true.
          MOVING(J) = .FALSE.
        END DO! OF M
*
        ITER      = ITER + 1
*
        GO TO 1
*
      END IF  !(.not.DONE
*
 1000 CONTINUE
*
      IF(ITER.GE.MAXIT) THEN
        PRINT "(/1X,'??? NO CONVERGENCE AFTER MAXIT INTERATIONS')"
        PRINT "(1X,'??? BOND BETWEEN ATOMS',I4,'  AND',I4,' '
     X      ,/'  EQ. BOND = ',F12.6,' A --> CALC.= ',F12.6,' A'/)"
     X      ,I,J,DSQRT(BNDSQ),DSQRT(BSQ)
      END IF
C   velocity correction
      DO I      = ISBEG,ISEND
        DIX       = (SX(I)-FX(I))/(MASSDI(I)*TSTEP)
        DIY       = (SY(I)-FY(I))/(MASSDI(I)*TSTEP)
        DIZ       = (SZ(I)-FZ(I))/(MASSDI(I)*TSTEP)
        VX(I)     = VX(I)+DIX
        VY(I)     = VY(I)+DIY
        VZ(I)     = VZ(I)+DIZ
        VIRA(1)=VIRA(1)+(OX(I)*DIX)/TSTEP
        VIRA(2)=VIRA(2)+(OY(I)*DIY)/TSTEP
        VIRA(3)=VIRA(3)+(OZ(I)*DIZ)/TSTEP
      END DO! OF N
*      call SUMMA(VIR11,VIRA,3,MAST)
*      VIR	= VIR+VIRA(1)+VIRA(2)+VIRA(3)
      RETURN
      END
